/*+
|                                               |
|     Trigger: DTULTATU_FILDIMEGRUPOP           |  
|     Tabela : FILDIMEGRUPOP                    |
|                                               |
|     Criao:                                  |
|     06/09/2007 - Luiz Passos                  |
|                                               |
+*/


create or replace TRIGGER DTULTATU_FILDIMEGRUPOP
BEFORE INSERT OR UPDATE OR DELETE
ON FILDIMEGRUPOP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFDIDWGR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRSEQUEDIME,0) <> NVL(:NEW.NRSEQUEDIME,0)) OR
         (NVL(:OLD.CDGRUPOPER,0) <> NVL(:NEW.CDGRUPOPER,0)) OR
         (NVL(:OLD.CDFILDIMEGRUPOP,0)  <> NVL(:NEW.CDFILDIMEGRUPOP,0))  THEN        
         
         :NEW.DTULTATUFDIDWGR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FILDIMEGRUPOP', '', 'NRSEQUEDIME='||:OLD.NRSEQUEDIME||';CDGRUPOPER='||:OLD.CDGRUPOPER||';CDFILDIMEGRUPOP='||:OLD.CDFILDIMEGRUPOP||';', SYSDATE);
   END IF;
END;
/


ALTER TABLE FILDIMEGRUPOP MODIFY DTULTATUFDIDWGR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_FILDIMEGRUPOP','4.11.176'); END;
/

