/*
 Nome: Limpeza de Dados do Estoque
 Criao:
 13/02/2006 - Renata Diniz Viana
 @C:\Web_407\Cli\Src\Cli\GRS\SQL\3810_STPPDVO_Limpeza_Vendas.SQL
*/

CREATE OR REPLACE PROCEDURE LIMPEZA_VENDAS_GR(
   P_DTLIMPEZA IN DATE)
AS

BEGIN

   FOR C_TURCAIXA IN
      (SELECT CDFILIAL, CDCAIXA, DTABERCAIX
       FROM TURCAIXA
       WHERE DTMOVTURCAIX < P_DTLIMPEZA) LOOP

       /*Movimentao do cliente*/
       DELETE FROM MOVICLIE
       WHERE CDFILIAL   = C_TURCAIXA.CDFILIAL AND
             CDCAIXA    = C_TURCAIXA.CDCAIXA  AND
             DTABERCAIX = C_TURCAIXA.DTABERCAIX;
       COMMIT;

       /*Movimentao do caixa*/
       DELETE FROM MOVCAIXA
       WHERE CDFILIAL   = C_TURCAIXA.CDFILIAL AND
             CDCAIXA    = C_TURCAIXA.CDCAIXA  AND
             DTABERCAIX = C_TURCAIXA.DTABERCAIX;
       COMMIT;

       /*Vendas*/
       FOR C_VENDAS IN (
          SELECT CDFILIAL, CDCAIXA, NRSEQVENDA
          FROM VENDA
          WHERE
             CDFILIAL  = C_TURCAIXA.CDFILIAL AND
             CDCAIXA   = C_TURCAIXA.CDCAIXA  AND
             DTABERTUR = C_TURCAIXA.DTABERCAIX) LOOP

          /*Movimentao do cliente*/
          DELETE FROM MOVICLIE
          WHERE CDFILIAL = C_VENDAS.CDFILIAL AND
                CDCAIXA  = C_VENDAS.CDCAIXA  AND
                NRSEQVENDA = C_VENDAS.NRSEQVENDA;
          COMMIT;


          /*Movimentao do caixa*/
          DELETE FROM MOVCAIXA
          WHERE CDFILIAL = C_VENDAS.CDFILIAL AND
                CDCAIXA  = C_VENDAS.CDCAIXA  AND
                NRSEQVENDA = C_VENDAS.NRSEQVENDA;
          COMMIT;


          /*Imposto dos itens */
          DELETE FROM ITVENDAIMPOS
          WHERE CDFILIAL = C_VENDAS.CDFILIAL AND
                CDCAIXA  = C_VENDAS.CDCAIXA  AND
                NRSEQVENDA = C_VENDAS.NRSEQVENDA;
          COMMIT;

          /*Itens cancelados*/
          DELETE FROM ITVENDACAN
          WHERE CDFILIAL   = C_VENDAS.CDFILIAL AND
                CDCAIXA    = C_VENDAS.CDCAIXA  AND
                NRSEQVENDA = C_VENDAS.NRSEQVENDA;
          COMMIT;

          /*Itens da venda*/
          DELETE FROM ITEMVENDA
          WHERE CDFILIAL   = C_VENDAS.CDFILIAL AND
                CDCAIXA    = C_VENDAS.CDCAIXA  AND
                NRSEQVENDA = C_VENDAS.NRSEQVENDA;
          COMMIT;

       END LOOP;
       /*Vendas*/
       DELETE FROM VENDA
       WHERE CDFILIAL  = C_TURCAIXA.CDFILIAL AND
             CDCAIXA   = C_TURCAIXA.CDCAIXA  AND
             DTABERTUR = C_TURCAIXA.DTABERCAIX;
       COMMIT;

       /*Fechamento de caixa */
       DELETE FROM FECHACAIXA
       WHERE CDFILIAL   = C_TURCAIXA.CDFILIAL AND
             CDCAIXA    = C_TURCAIXA.CDCAIXA  AND
             DTABERCAIX = C_TURCAIXA.DTABERCAIX;
       COMMIT;

   END LOOP;

   /*Abertura de caixa */
   DELETE FROM TURCAIXA
   WHERE DTMOVTURCAIX < P_DTLIMPEZA;
   COMMIT;

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LIMPEZA_VENDAS_GR','4.07.045'); END;
/

