/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPAUDIT                                                 */
/* Tabela : TIPAUDIT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPAUDIT'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPAUDIT
GO

CREATE TRIGGER DTULTATU_TIPAUDIT
ON TIPAUDIT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPAUDIT', null, 'CDTIPAUDIT='+ CDTIPAUDIT+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPAUDIT
      SET DTULTATUTAUD = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPAUDIT.CDTIPAUDIT,0) = ISNULL(INSERTED.CDTIPAUDIT,0)) AND
            (ISNULL(TIPAUDIT.NMTIPAUDIT,0) = ISNULL(INSERTED.NMTIPAUDIT,0));
   END;
END;
GO

