/* Tabela MAPACOMPERIODO*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MAPACOMPERIODO*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela MAPACOMPERIODO, utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_EXP_MAPACOMPERIODO' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_EXP_MAPACOMPERIODO
GO
CREATE TRIGGER LOG_EXP_MAPACOMPERIODO
ON MAPACOMPERIODO
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDVENDEDOR_NEW      VARCHAR(4);
  DECLARE @V_CDFILICOMIS_NEW     VARCHAR(4);
  DECLARE @V_NRMAPACOMIS_NEW     VARCHAR(10);
  DECLARE @V_DTINIPERIODO_NEW    DATETIME;
  DECLARE @V_DTFIMPERIODO_NEW    DATETIME;
  DECLARE @V_IDBLOQMAPACOMIS_NEW VARCHAR(1);
  DECLARE @V_NMMAPACOMIS_NEW     VARCHAR(100);

  DECLARE @V_CDVENDEDOR_OLD      VARCHAR(4);
  DECLARE @V_CDFILICOMIS_OLD     VARCHAR(4);
  DECLARE @V_NRMAPACOMIS_OLD     VARCHAR(10);
  DECLARE @V_DTINIPERIODO_OLD    DATETIME;
  DECLARE @V_DTFIMPERIODO_OLD    DATETIME;
  DECLARE @V_IDBLOQMAPACOMIS_OLD VARCHAR(1);
  DECLARE @V_NMMAPACOMIS_OLD     VARCHAR(100);


   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';

   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL,
         CDVENDEDOR,
         CDFILICOMIS,
         NRMAPACOMIS,
         DTINIPERIODO,
         DTFIMPERIODO,
         IDBLOQMAPACOMIS,
         NMMAPACOMIS
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDVENDEDOR,
         INSERTED.CDFILICOMIS,
         INSERTED.NRMAPACOMIS,
         INSERTED.DTINIPERIODO,
         INSERTED.DTFIMPERIODO,
         INSERTED.IDBLOQMAPACOMIS,
         INSERTED.NMMAPACOMIS,

         DELETED.CDVENDEDOR,
         DELETED.CDFILICOMIS,
         DELETED.NRMAPACOMIS,
         DELETED.DTINIPERIODO,
         DELETED.DTFIMPERIODO,
         DELETED.IDBLOQMAPACOMIS,
         DELETED.NMMAPACOMIS

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDVENDEDOR  = DELETED.CDVENDEDOR  AND
         INSERTED.CDFILICOMIS = DELETED.CDFILICOMIS AND
         INSERTED.NRMAPACOMIS = DELETED.NRMAPACOMIS

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDVENDEDOR,
         INSERTED.CDFILICOMIS,
         INSERTED.NRMAPACOMIS,
         INSERTED.DTINIPERIODO,
         INSERTED.DTFIMPERIODO,
         INSERTED.IDBLOQMAPACOMIS,
         INSERTED.NMMAPACOMIS,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_R;
   FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                   @V_CDVENDEDOR_NEW, @V_CDFILICOMIS_NEW, @V_NRMAPACOMIS_NEW, @V_DTINIPERIODO_NEW, @V_DTFIMPERIODO_NEW,
                                   @V_IDBLOQMAPACOMIS_NEW, @V_NMMAPACOMIS_NEW,

                                   @V_CDVENDEDOR_OLD, @V_CDFILICOMIS_OLD, @V_NRMAPACOMIS_OLD, @V_DTINIPERIODO_OLD, @V_DTFIMPERIODO_OLD,
                                   @V_IDBLOQMAPACOMIS_OLD, @V_NMMAPACOMIS_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_TIPO = 'D' BEGIN

         IF @V_CDVENDEDOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Vendedor = ' + ISNULL(@V_CDVENDEDOR_OLD,'') + ' ';
         END;
         IF @V_CDFILICOMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial = ' + ISNULL(@V_CDFILICOMIS_OLD,'') + ' ';
         END;
         IF @V_NRMAPACOMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nmero do mapa = ' + ISNULL(@V_NRMAPACOMIS_OLD,'') + ' ';
         END;
         IF @V_DTINIPERIODO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Data Inicial = ' + ISNULL(CONVERT(VARCHAR,@V_DTINIPERIODO_OLD),'') + '% ';
         END;
         IF @V_DTFIMPERIODO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Data Final = ' + ISNULL(CONVERT(VARCHAR,@V_DTFIMPERIODO_OLD),'') + '% ';
         END;
         IF @V_IDBLOQMAPACOMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Bloqueado = ' + ISNULL(@V_IDBLOQMAPACOMIS_OLD,'') + ' ';
         END;
         IF @V_NMMAPACOMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nome do mapa = ' + ISNULL(@V_NMMAPACOMIS_OLD,'') + ' ';
         END;

         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_CDVENDEDOR_OLD + @V_CDFILICOMIS_OLD + @V_NRMAPACOMIS_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
             IF (@V_CDVENDEDOR_OLD      <> @V_CDVENDEDOR_NEW     ) OR
                (@V_CDFILICOMIS_OLD     <> @V_CDFILICOMIS_NEW    ) OR
                (@V_NRMAPACOMIS_OLD     <> @V_NRMAPACOMIS_NEW    ) OR
                (@V_DTINIPERIODO_OLD    <> @V_DTINIPERIODO_NEW   ) OR
                (@V_DTFIMPERIODO_OLD    <> @V_DTFIMPERIODO_NEW   ) OR
                (@V_IDBLOQMAPACOMIS_OLD <> @V_IDBLOQMAPACOMIS_NEW) OR
                (@V_NMMAPACOMIS_OLD     <> @V_NMMAPACOMIS_NEW    ) BEGIN

               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_CDVENDEDOR_OLD + @V_CDFILICOMIS_OLD + @V_NRMAPACOMIS_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_CDVENDEDOR_NEW + @V_CDFILICOMIS_NEW + @V_NRMAPACOMIS_NEW;
         END;

         IF ISNULL(@V_CDVENDEDOR_NEW, '!') <> ISNULL(@V_CDVENDEDOR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Vendedor = ' + @V_CDVENDEDOR_NEW;
         END;
         IF ISNULL(@V_CDFILICOMIS_NEW, '!') <> ISNULL(@V_CDFILICOMIS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Filial = ' + @V_CDFILICOMIS_NEW;
         END;
         IF ISNULL(@V_NRMAPACOMIS_NEW, '!') <> ISNULL(@V_NRMAPACOMIS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Nmero do mapa = ' + @V_NRMAPACOMIS_NEW;
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_DTINIPERIODO_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTINIPERIODO_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Data Inicial = ' + @V_DTINIPERIODO_NEW;
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_DTFIMPERIODO_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTFIMPERIODO_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Data Final = ' + @V_DTFIMPERIODO_NEW;
         END;
         IF ISNULL(@V_IDBLOQMAPACOMIS_NEW, '!') <> ISNULL(@V_IDBLOQMAPACOMIS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Bloqueado = ' + @V_IDBLOQMAPACOMIS_NEW;
         END;
         IF ISNULL(@V_NMMAPACOMIS_NEW, '!') <> ISNULL(@V_NMMAPACOMIS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Nome do mapa = ' + @V_NMMAPACOMIS_NEW;
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN

            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                CDFILLOGOPER,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('MAPACOMPERIODO',
                @V_DTOPER,
                @V_USUARIO,
                @V_TPMOVI,
                @V_ITPESQ,
                SUBSTRING(@V_DESC,1,300),
                @V_CDFILLOGOPER,
                @V_DSSERVERRDM,
                @V_DSREMOTEADDR,
                @V_DSREMOTEHOST,
                @V_DSSERVMETHOD,
                @V_DSREMOTEOPER);

         END;
      END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                      @V_CDVENDEDOR_NEW, @V_CDFILICOMIS_NEW, @V_NRMAPACOMIS_NEW, @V_DTINIPERIODO_NEW, @V_DTFIMPERIODO_NEW,
                                      @V_IDBLOQMAPACOMIS_NEW, @V_NMMAPACOMIS_NEW,

                                      @V_CDVENDEDOR_OLD, @V_CDFILICOMIS_OLD, @V_NRMAPACOMIS_OLD, @V_DTINIPERIODO_OLD, @V_DTFIMPERIODO_OLD,
                                      @V_IDBLOQMAPACOMIS_OLD, @V_NMMAPACOMIS_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_EXP_MAPACOMPERIODO','5.85.XXX';
GO