<?php
namespace Teknisa\CRM\Service;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class GeraTarefaAniverAnoAtualProcedure {
	
	protected $connection;
	
	public function __construct(Connection $connection) {
		
		$this->connection = $connection;
		
	}

	public function executeProcedure($row) {
		
		$this->connection->beginTransaction();
		
		try{
			
			$generateTasksByBirthdayProcedure = new StoredProcedure($this->connection, "GERA_TAREFA_ANIVER_ANO_ATUAL");
			
			$generateTasksByBirthdayProcedure->addParam(new Param('V_ANO_TAREFAS', Param::PARAM_INPUT, $row["ANO_TAREFAS"]));
			$generateTasksByBirthdayProcedure->addParam(new Param('V_HORA_TAREFA', Param::PARAM_INPUT, $row["HORA_TAREFAS"]));
			$generateTasksByBirthdayProcedure->addParam(new Param('V_DESCRICAO_TAREFA', Param::PARAM_INPUT, $row["DSFILACONTATO"]));
			$generateTasksByBirthdayProcedure->addParam(new Param('V_NRORG', Param::PARAM_INPUT, intval($row["NRORG"])));	
			$generateTasksByBirthdayProcedure->addParam(new Param('V_CODIGO_OPERADOR_LOGADO', Param::PARAM_INPUT, $row["CDOPERADOR"]));
			
			$generateTasksByBirthdayProcedure->execute();
			$this->connection->commit();
			
			
		} catch(Exception $e){
			
			$this->connection->rollBack();
			throw $e;
			
		}
	}
	
}