/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESCOLA                                                   */
/* Tabela : ESCOLA                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 15/09/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ESCOLA' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATU_ESCOLA
GO

CREATE TRIGGER DTULTATU_ESCOLA
ON ESCOLA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ESCOLA', null, 'CDESCOLA=' + CDESCOLA + ';',                                GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE ESCOLA
      SET DTULTATUESCO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ESCOLA.CDESCOLA,0) = ISNULL(INSERTED.CDESCOLA,0)) AND                          (ISNULL(ESCOLA.NMESCOLA,0) = ISNULL(INSERTED.NMESCOLA,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ESCOLA','5.05.003';
GO

