/* Sistemas Integrados TECNISA

Nome: 3515_GERTRGS_DTULTATU_HABILOPER.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela HABILOPER

Criao:
14/09/2007 Pablo Henrique dos Reis

*/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_HABILOPER' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_HABILOPER
  GO

CREATE TRIGGER DTULTATU_HABILOPER
ON HABILOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'HABILOPER', 'CDOPERADOR=' + CDOPERADOR+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE HABILOPER
      SET  DTULTATUHAOP = GETDATE()
      FROM INSERTED
      WHERE ISNULL(HABILOPER.CDOPERADOR,0) = ISNULL(INSERTED.CDOPERADOR,0);
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_HABILOPER','4.11.179';
GO
