function InterlocutoresPendentes(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General, CRM_Utilities, restEngine, ChamadoController) {

    this.changeLabel = function(widget){
        var action = widget.getAction('SENT_MAIL');
        if(widget.getCheckedRows().length > 1)
            action.label = 'Reenviar Email de Ativação aos interlocutores';
        else
            action.label = 'Reenviar Email de Ativação ao interlocutor';
    };
    
    this.openPopupSetClient = function(widget){
        if(widget.currentRow.ATIVO === 'S'){
            var popUp = templateManager.container.getWidget('WDGT_SET_CLIENT');
            popUp.currentRow = {};
            popUp.isVisible =true;
            ScreenService.openPopup(popUp);
        }else{
            ScreenService.confirmMessage('O interlocutor precisa ser ativado para atribuir um cliente.  </br>Deseja reenviar o email de ativação?', 'QUESTION',
            function(success){
                this.sentMail(widget);
            }.bind(this));
        }
    };
    
    this.sentMail = function(widget){
        var mainWidget = templateManager.container.getWidget('WDGT_INTERLOCUTORES');
        var rows;
        if(mainWidget.getCheckedRows().length === 0)
            rows = [mainWidget.currentRow];
        else
            rows = mainWidget.getCheckedRows();
            
        var rowsToBackend = [];    
        
        rows.forEach(function(interloc){
            var row = {
                NRPARCNEGOCIO: interloc.NRPARCNEGOCIO,
                NMINTERLOCUTOR: interloc.NMINTERLOCUTOR,
                EMAIL:interloc.EMAILINTERLOC,
                NRSEQINTERLOCUTOR:interloc.NRSEQINTERLOCUTOR,
                NRORG: interloc.NRORG
            };
            rowsToBackend.push(row);
        });
        
        var paramsRestEngine = {
            requestType:"DataSet",
            dataset:rowsToBackend
        };
        
        restEngine.post('product#/sentConfirmationMail', paramsRestEngine).
            then(function(response){
                if(response.dataset.INTERLOCUTOR){
                    ScreenService.showMessage('Email enviado com sucesso!').then(function(){
                        mainWidget.dataSource.clearCheckedRows();
                        mainWidget.reload();
                    });
                }    
            }).catch(function(error){
                ScreenService.showMessage(error.data.error);    
            });
    };
    
    this.setClient = function(widget){
        var mainWidget = templateManager.container.getWidget('WDGT_INTERLOCUTORES');
        var interloc = mainWidget.currentRow;
        var rowsToBackend = [];
        
        var row = {
            NRPARCNEGOCIOINTERLOCUTOR: interloc.NRPARCNEGOCIO,
            NMINTERLOCUTOR: interloc.NMINTERLOCUTOR,
            CDCLIENTE: widget.currentRow.CDCLIENTE,
            NRPARCNEGOCIOCLIENTE:widget.currentRow.NRPARCNEGOCIO,
            NRSEQINTERLOCUTOR:interloc.NRSEQINTERLOCUTOR,
            NRORG:interloc.NRORG
        };
        rowsToBackend.push(row);
        
        var paramsRestEngine = {
            requestType:"DataSet",
            dataset:rowsToBackend
        };
        
        restEngine.post('product#/setClientInPendInt', paramsRestEngine).
            then(function(response){
                if(response.dataset.INTERLOCUTOR){
                    ScreenService.showMessage('Cliente Atribuido ao Interlocutor');
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe().then(function(){
                        mainWidget.reload();
                    });
                }    
            }).catch(function(error){
                ScreenService.showMessage(error.data.error);    
            });
    };
    
    this.cancelInterloc = function(widget){
        ScreenService.confirmMessage('Deseja realmente excluir o interlocutor e cancelar todos os seus tickets?', 'QUESTION',
        function(success){
            var paramsRestEngine = {
                requestType:'Row',
                row:widget.currentRow
            };
            
            restEngine.post('product#/cancelInterloc', paramsRestEngine).
                then(function(response){
                    if(response.dataset.INTERLOCUTOR){
                        ScreenService.showMessage('Interlocutor excluido e Tickets cancelados');
                        ScreenService.closeSwipe().then(function(){
                            ScreenService.closePopup(true);
                            widget.reload();
                        });
                    }    
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);    
                });        
        }, 
        function(cancel){
            
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('InterlocutoresPendentes', InterlocutoresPendentes);
});