function RelatorioCustomizavelProspectController(templateManager, CRM_Utilities) {
    
   this.setEstado = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.getField("NMESTADO");
        if(!Util.isEmptyOrBlank(pais)){
            estado.readOnly = false;
            estado.dataSourceFilter[0].value = pais;
        }else{
            estado.readOnly = true; 
            estado.clearValue();
            estado.dataSourceFilter[0].value = "";
            args.owner.owner.widget.currentRow.SGESTADO = "";
            this.setMunicipio(args);
        }    
       
   };
   
   this.setMunicipio = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.currentRow.SGESTADO;
        var municipio = widgetFiltro.getField("NMMUNICIPIO");
        if(!Util.isEmptyOrBlank(estado)){
            municipio.readOnly = false;
            municipio.dataSourceFilter[0].value = pais;
            municipio.dataSourceFilter[1].value = estado;
        }else{
            municipio.readOnly = true; 
            municipio.clearValue();
            municipio.dataSourceFilter[0].value = "";
            municipio.dataSourceFilter[1].value = "";
            args.owner.owner.widget.currentRow.CDMUNICIPIO = "";
            this.setBairro(args);
        }    
       
   };
   
    this.setBairro = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.currentRow.SGESTADO;
        var municipio = widgetFiltro.currentRow.CDMUNICIPIO;
        var bairro = widgetFiltro.getField("NMBAIRPROS");
        if(!Util.isEmptyOrBlank(municipio)){
            bairro.readOnly = false;
            bairro.dataSourceFilter[0].value = pais;
            bairro.dataSourceFilter[1].value = estado;
            bairro.dataSourceFilter[2].value = municipio;
        }else{
            bairro.readOnly = true; 
            bairro.clearValue();
            bairro.dataSourceFilter[0].value = "";
            bairro.dataSourceFilter[1].value = "";
            bairro.dataSourceFilter[2].value = "";
        }    
       
   };
   
   this.setFilterOpportunityByParc = function(args){
        var widgetFiltro = args.owner.owner.widget;
        var nrParc       = widgetFiltro.getField("NRPARCNEGOCIO").value();
        var oppor        = widgetFiltro.getField("NRSEQOPORT");
        oppor.clearValue();
        oppor.dataSourceFilter.forEach(function(filter, index, dataSourceFilter){
            if(filter.name === "NRPARCOPORT")
                dataSourceFilter.splice(index, 1);    
        });
        if(!Util.isEmptyOrBlank(nrParc)){
            var filter = {};
            filter.name     = "NRPARCOPORT";
            filter.operator = "IN";
            filter.value    = nrParc;
            oppor.dataSourceFilter.push(filter);
        }
        
   };
   
   /**
     * Define as regras da tela de relatórios de prospect 
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de relatórios de prospect 
     * ('layoutPrincipal').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)){
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            if(widget.name === 'evolucao'){
                restrictObjects.push(widget.getField("NRPARCNEGOCIO__LABEL"));
            }
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
    this.unMaskPhone = function(widget){
        widget.dataSourceFilter.forEach(function(filter){
            if(filter.name === "TELEFONES"){
                filter.value = '%'+ CRM_Utilities.removeValueMask(filter.value) + '%'; 
            }    
        });
    };
    
    this.fazerCopiaDataSource = function(widget) {
        var ds = widget.dataSource;
        ds.dataCopy = ds.data;
    };
    
    this.agruparFieldsVisiveis = function(widget) {
        var loadedData = widget.dataSource.dataCopy;
        var visibleFields = widget.fields.filter(function(field) {
            return field.isVisible == field.showOnList == true; 
        });
        
        var columnsToGroup = visibleFields.map(function(field) {
            return field.name;
        });
        
        if(!Util.isEmptyOrBlank(loadedData)) {
            var groupedRows = CRM_Utilities.groupBy(loadedData, columnsToGroup)
                .map(function(row) {
                    return row.value;
                });
        
            widget.dataSource.data = groupedRows;
        }
    };
    
    this.consertarOrdenacaoPorData = function(widget) {
        var orderingByDate = this.estaOrdenandoPorData(widget);
        
        if (!orderingByDate) {
            return;
        }
        
        var rows       = widget.dataSource.dataCopy;
        var sortedRows = rows.sort(this.comparaDatas);
        var sentido    = this.findSentidoOrdenacao(widget);
        
        if (sentido === 'DESC') {
            sortedRows.reverse();
        }
        
        widget.dataSource.data = sortedRows;
        widget.redraw();
    };
    
    this.estaOrdenandoPorData = function(widget) {
        var filtroOrderBy = widget.dataSourceFilter.find(filter => {
            return filter.operator === 'ORDER_BY';
        });
        
        if (Util.isEmptyOrBlank(filtroOrderBy)) {
            return false;
        }
        
        return filtroOrderBy.name[0].name === '__proxy_DTHREVOLCONT' ||
               filtroOrderBy.name[0].name === 'DTHREVOLCONT';
    };
    
    this.comparaDatas = function(row1, row2) {
        var date1 = moment(row1.DTHREVOLCONT, 'DD/MM/YYYY HH:mm:ss').valueOf();
        var date2 = moment(row2.DTHREVOLCONT, 'DD/MM/YYYY HH:mm:ss').valueOf();
        
        return date1 - date2;
    };
    
    this.findSentidoOrdenacao = function(widget) {
        var filtroOrderBy = widget.dataSourceFilter.find(filter => {
            return filter.operator === 'ORDER_BY';
        });
        
        return filtroOrderBy.name[0].direction;
    };
    
    this.relatorioAfteLoadDataSource = function(widget) {
        this.fazerCopiaDataSource(widget);
        this.agruparFieldsVisiveis(widget);
        this.consertarOrdenacaoPorData(widget);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("RelatorioCustomizavelProspectController", RelatorioCustomizavelProspectController);
});

