function RelatorioLeadOperadorController(CRM_Utilities, templateManager) {
    
    this.tabLeadOnEnter = function(widget) {
        this.tabOnEnter(widget, 'P_NRORG', 'NRPARCPROPRI', 'IDTPOPERADOR',
            'IDATIVO', 'DTINCLUSAO', 'LEADACTIVE');
    };
    
    this.tabProspectOnEnter = function(widget) {
        this.tabOnEnter(widget, 'NRORG', 'NRPARCRESPROSP', 'IDTPOPERADOR',
            'IDATIVO', 'DTINCLUSAO', 'PROSACTIVE');
    };
    
    this.tabOnEnter = function(widget, nrorg, nrparcnegocio, idtpoperador,
        idativo, dtinclusao, ativoFiltro) {
            
        // Necessário para que a função gerarDataSourceTab seja compatível
        // com as duas tabs!
        var columnNames = {
            NRORG: nrorg,
            NRPARCNEGOCIO: nrparcnegocio,
            IDTPOPERADOR: idtpoperador,
            IDATIVO: idativo,
            DTINCLUSAO: dtinclusao,
            ativoFiltro: ativoFiltro
        };
        
        this.gerarDataSourceTab(widget, columnNames);
        widget.reload();
    };
  
    this.gerarDataSourceTab = function(widget, columnNames) {
        var parentWdg = widget.parent.parent;
        
        widget.dataSourceFilter = [];
        
        var valorNRORG = getLocalVar('CRM_NRORG');
        
        var valorNRPARCNEGOCIO = parentWdg.currentRow.CDRESPONSAVEL;
        
        var valorIDTPOPERADOR = Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR) ?
            'E' : templateManager.LOGGEDOPERATOR.IDTPOPERADOR;
        
        var filtroIdAtivo = parentWdg.dataSourceFilter.find(function(filtro) {
            return filtro.name == columnNames.ativoFiltro;
        });
        var valorIDATIVO = filtroIdAtivo ? filtroIdAtivo.value : null;
        
        var filtroPeriodo = parentWdg.dataSourceFilter.find(function(filtro) {
            return filtro.name == 'DATEINTERVAL';
        });
        var valorPERIODO = filtroPeriodo ? filtroPeriodo.value : null;
        
        var options = [
            {
                "name": columnNames.NRORG,
                "operator": "=",
                "value": valorNRORG || null
            },
            {
                "name": columnNames.NRPARCNEGOCIO,
                "operator": "=",
                "value": valorNRPARCNEGOCIO || null
            },
            {
                "name": columnNames.IDTPOPERADOR,
                "operator": "=",
                "value": valorIDTPOPERADOR || null
            },
            {
                "name": columnNames.IDATIVO,
                "operator": "=",
                "value": valorIDATIVO || null
            },
            {
                "name": columnNames.DTINCLUSAO,
                "operator": "BETWEEN",
                "value": valorPERIODO || null
            }
        ];
        
        // Usa somente os filtros que tem valor válido (diferente de null,
        // undefined, etc
        var filters = options.filter(function(filter) {
            return filter.value ? true : false;
        });
        
        widget.dataSourceFilter.push(...filters);
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('RelatorioLeadOperadorController', RelatorioLeadOperadorController);
});